<?php

namespace Teknisa\DF\Modules\Entrada\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Dfe18500DocumentosParaComposicaoDeCustosFactory {
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function produtoItemproduto($nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT 
                    P.CDARVPROD,
                    P.NMPRODUTO,
                    IP.QTITEMPROD,
                    IP.VRUNITITEM,
                    IP.VRTOTAITEM
                FROM
                    ITEMPRODUTO IP,
                    PRODUTO P
                WHERE 
                    P.CDPRODUTO     = IP.CDPRODUTO    AND
                    IP.NRLANCTONF   = :P_NRLANCTONF   AND 
                    IP.CDFILIAL     = :P_CDFILIAL     AND
                    IP.NRORG        = :P_NRORG";
            
        $params = array("P_NRLANCTONF"  => $nrlanctonf,
                        "P_CDFILIAL"    => $cdfilial,
                        "P_NRORG"       => $nrorg);
                
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function insereRateioit($cdfilial, $nrlanctonf, $nrorg, $vrrateio) {
        $sql = "INSERT INTO RATEIOCUSTOIT (CDFILIAL, NRLANCTONF, NRORG, NRSEQITPROD, VRRATEIO) values (:CDFILIAL, :NRLANCTONF, :NRORG, :NRSEQITPROD, :VRRATEIO)";
        
        $params = array("NRLANCTONF"  => $nrlanctonf,
                        "CDFILIAL"    => $cdfilial,
                        "NRORG"       => $nrorg,
                        "VRRATEIO"    => $vrrateio);
                        
        $std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);

    }
    
    public function updateRateioit($cdfilial, $nrlanctonf, $nrorg, $vrrateio) {
        $sql = " UPDATE  RATEIOCUSTOIT 
                    SET  VRRATEIO = :VRRATEIO 
                  WHERE   
                        CDFILIAL    = :CDFILIAL     AND 
                        NRLANCTONF  = :NRLANCTONF   AND
                        NRORG       = :NRORG        AND
                        NRSEQITPROD = :NRSEQITPROD";
        
        $params = array("NRLANCTONF"  => $nrlanctonf,
                        "CDFILIAL"    => $cdfilial,
                        "NRORG"       => $nrorg,
                        "VRRATEIO"    => $vrrateio);
                        
        $std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);

    }
}