<?php

namespace Teknisa\DF\Modules\Saida\Services;

use Teknisa\DF\Modules\Saida\Factories\Dfs61000ConsultaloteFactory;


class Dfs61000ConsultaloteService {
    protected $consultaLoteFactory;
    
    public function __construct(Dfs61000ConsultaloteFactory $consultaLoteFactory) {
        $this->consultaLoteFactory = $consultaLoteFactory;
    }
    
    public function alteraStatusEmail($nrlanctonf, $cdfilial, $nrorg) {
        $this->consultaLoteFactory->alteraStatusEmail($nrlanctonf, $cdfilial, $nrorg);
    }
    
    public function getLote($nrseqloterps, $cdemploterps, $nrorg) {
        $lote = $this->consultaLoteFactory->getLote($nrseqloterps, $cdemploterps, $nrorg);
        return $lote;
    }
    
    public function getErroNotaPorRps($nrrps, $nrorg, $cdempresa, $dserro) {
        $nrrps = str_pad($nrrps, 15, "0", STR_PAD_LEFT);
        $nota  = $this->consultaLoteFactory->getNotaPorRps($nrrps, $nrorg, $cdempresa);
        if(!isset($nota[0])) {
            return null;
        }
        else {
            $nota = $nota[0];
            return array(
                "NRLANCTONF" => $nota['NRLANCTONF'],
                "NRNOTAFISC" => $nota['NRNOTAFISC'],
                "TIPODEERRO" => '3',
                "VRNOTAFISC" => $nota['VRNOTAFISC'],
                "DTEMISSAO"  => $nota['DTEMISSAO'],
                "DSERRO"     => $dserro
            );
        }
    }
    
    public function getCarteira($cdFilial, $nrLanctonf) {
        $carteira = $this->consultaLoteFactory->getCarteira($cdFilial, $nrLanctonf)[0]["CDCARTCOBBOL"];
        return $carteira;
    }
}